// Testing program for the Gene class
// John Dunkelberg

#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

#include "config.H"
#include "problem.H"
#include "chromosone.H"

extern "C"
{
  long random(void);
  void srandom(int);
  char *sprintf(const char *fmt, ... );
  char *strdup(char *);
}

main(int argc, char **argv)
{
  Problem *problem;
  Chromosone *tplate, *real, *test;
  Gene *fgene, *lgene;
  Gene *eugene, *phosgene;
  char *mesh_fname;

  double fitness;

  problem = new Problem;
  mesh_fname = new char[MAXLINE];

  if (argc > 0)
    {
      mesh_fname = strdup(argv[1]);
    }
  else
    {
      cout << "\nMesh filename? ";
      cin >> mesh_fname;
    }

  fstream in_fp(mesh_fname,ios::in);

  cout << "got " << mesh_fname << endl;

  problem->Initialize(in_fp);
  problem->Show(DEBUG);

  {
    tplate = new Chromosone;

    fgene = new Gene;
    fgene->Assign(0,0);
    lgene = new Gene;
    lgene->Assign(1,1);
    fgene->Connect(lgene);

    eugene = new Gene;
    eugene->Assign(2,2);
    lgene->Connect(eugene);
    lgene = eugene;

    eugene = new Gene;
    eugene->Assign(3,3);
    lgene->Connect(eugene);
    lgene = eugene;

    eugene = new Gene;
    eugene->Assign(4,4);
    lgene->Connect(eugene);
    lgene = eugene;

    tplate->Assign(100,fgene);

    cout << "Template \n";
    tplate->Show(DEBUG);
  }

  {
    real = new Chromosone;

    fgene = new Gene;
    fgene->Assign(0,12);
    lgene = new Gene;
    lgene->Assign(1,15);
    fgene->Connect(lgene);

    eugene = new Gene;
    eugene->Assign(2,22);
    lgene->Connect(eugene);

    real->Assign(113,fgene);

    cout << "Real Chromosone\n";
    real->Show(DEBUG);
  }

  {
    test = new Chromosone;

    test = tplate->Copy();
    test->Splice(real);

    cout << "Test Chromosone\n";
    test->Show(DEBUG);
  }

  fitness = real->Fitness(problem,tplate);
  cout << "fitness " << fitness << endl;
  real->Show(DEBUG);
}
