/*
 * Messy Genetic Algorithm
 * Proof of Principle Program (one era)
 *
 * John Dunkelberg
 */

main()
{
  /* Control Variables that we need to know:
   *
   * Problem definition:
   * prob_size: number of FEM elements in the problem (also chromosone length)
   * mach_size: number of processing elements in the SIMD machine
   * mach_side: the length of a side of the SIMD (sqrt(mach_size))
   *
   * Algorithmic definition:
   * order:     length of the building blocks targetted
   *
   * Population Controls:
   * init_pop_size:  size of the full population (all BBs)
   * juxt_pop_size:  size of the population during the juxtapositional phase
   *
   * Time line (end markers):
   * 0 time           (init_pop_size) BBs are created
   * init_select_gen: stop the no-shuffle, start shuffle,
   *                  cut init_pop_size every other gen
   * cut_every_other_gen: shuffle tournament continues,
   *                  switch to every gen cut pop_size in half
   * cut_pop_gen: shuffle tournament continues,
   *                  keep population size stable at juxt_pop_size
   * prim_gen: end of the primordial phase, start cut & splice
   *                  population size remains constant
   * max_gen: this is the end
   */

  int gen, max_gen;
  long pop_size;

  Pop Cur_Pop;
  PPop Pcur_Pop = &Cur_Pop;

  /* Master loop (all generations) */
  for(gen=0;(gen<max_gen);gen++)
    {
      if (gen==0)
	init_pop_size = pop_size = Pcur_Pop.Initialize(prob_size,
						       mach_size,order);
      else if (gen < init_select_gen)
	pop_size = Pcur_Pop.Init_Select(pop_size);
      else if (gen < cut_every_other_gen)
	if (gen % 2)
	  pop_size = Pcur_Pop.Select((pop_size /2));
	else
	  pop_size = Pcur_Pop.Select(pop_size);
      else if (gen < cutpop_gen)
	pop_size = Pcur_Pop.Select((pop_size/2));
      else if (gen < prim_gen)
	pop_size = Pcur_Pop.Select(pop_size);
      else
	pop_size = Pcur_Pop.Juxta(juxt_pop_size);

      if (DEBUG != 0)
	Pcur_Pop.Debug(DEBUG);
    }
  Pcur_Pop.Show();
}
